/**
 * wii_imet.h
 */

#ifndef __WII_IMET_H__
#define __WII_IMET_H__

#include "types.h"

#define IMET_NAME_SIZE 42
#define IMET_NAME_COUNT 7

#define IMET_OFFSET 0x80

enum IMET_LANGUAGES {
	IMET_LANG_JP = 0,
	IMET_LANG_EN = 1,
	IMET_LANG_DE = 2,
	IMET_LANG_FR = 3,
	IMET_LANG_ES = 4,
	IMET_LANG_IT = 5,
	IMET_LANG_NL = 6
};

typedef struct {
	char magic[4];		/* "IMET" */
	u32 ukn0;		/* Always 00 00 06 00 */
	u32 ukn1;		/* Always 00 00 00 03 */
	u32 ukn_size1;
	u32 ukn_size2;
	u32 ukn_size3;
	u32 ukn_flags;
	u16 name[IMET_NAME_COUNT][IMET_NAME_SIZE];
} wii_imet;

typedef struct {
	char dirname[0x20];
	u32 ukn_pad[3];
	u16 unk_flag0;
	u16 unk_flag1;
	char host[0x10];
} wii_build_info;

#endif
