/**
 * wii_tik.h
 */

#ifndef __WII_TIK_H__
#define __WII_TIK_H__

#include <stdio.h>
#include "types.h"

typedef struct {
	u32 tag;
	u32 value;
} wii_tik_limit;

typedef struct {
	u32 sig_type;
	u8 signature[0x100];
	u8 ukn0[0x3c];
	char issuer[64];
	u8 ukn1[0x3f];
	u8 title_key_enc[0x10];
	u8 unk2;
	u64 ticket_id;
	u32 console_id;
	u32 title_category;
	u32 title_id;
	u16 access_mask;
	u16 bought_dlc_contents;
	u64 unk4;
	u8 common_key_index;		/* 1 = Korean Key, 0 = Common Key */
	u8 unk5[0x30];
	u8 unk6[0x20];
	u16 unk7;
	u32 has_time_limit;
	u32 time_limit_sec;		/* Seconds */
	u8 unk8[0x58];
} wii_tik;

void tik_read(FILE *f, wii_tik *tik);
void print_tik(wii_tik *tik);

#endif
